#pragma once

#include <vector>
#include <cstdint>
#include <ReArchive/types/FileEntry.h>

namespace ReArchive {
    class FileTable;
}

class ReArchive::FileTable {
protected:
    // count
    std::vector<FileEntry> entries;
public:
    void Append(const FileEntry& file_entry);
    void Remove(const FileEntry& file_entry);
    [[nodiscard]] std::vector<FileEntry> GetEntries() const { return entries; }
    [[nodiscard]] int64_t Count() const { return entries.size(); }
public:
    [[nodiscard]] static std::vector<unsigned char> Serialize(const FileTable& file_table);
public:
    FileTable() = default;

};